// HTML2EMail
// encoding routines
// (c)2002,2003 Oliver Michalak / werk01.de

function dec2hex(v) { // two digits
	return ("0123456789ABCDEF".charAt((v/16) & 0x0F)+"0123456789ABCDEF".charAt(v & 0x0F));
}

function hex2dec(v) {
	var res = 0;
	for (i=0; i<v.length; i++) {
		var val = v.charCodeAt(i);
		if (val>=48 && val<=57)	// number
			res += (val-48)*(1<<(4*(v.length-1-i)));
		else if (val>=65 && val<=70)	// A-F
			res += (val-65+10)*(1<<(4*(v.length-1-i)));
		else if (val>=97 && val<=102)	// a-f
			res += (val-97+10)*(1<<(4*(v.length-1-i)));
	}
	return res;
}

// id-builder
function id (len) {
	var result = '';
	for (var i=0; i<len; i++)
		if (i%2)
			result += String.fromCharCode (65+Math.floor(26*Math.random()));
		else
			result += String.fromCharCode (48+Math.floor(10*Math.random()));
	return (result);
}

// converts single char to base64-table (rfc2045)
function b642c (code) {
	var result = 0;

	if (0 <= code && code <= 25)
		result = String.fromCharCode(code + 65);
	else if (26 <= code && code <= 51)
		result = String.fromCharCode(code - 26 + 97);
	else if (52 <= code && code <= 61)
		result = String.fromCharCode(code - 52 + 48);
	else if (code == 62)
		result = '+';
	else if (code == 63)
		result = '/';
	else
		result = String.fromCharCode(0xFF);
	return (result);
}

// converts str to base64 (rfc2045)
function b64encode (str) {
	var result = '';
	var code = '';
	var i = 0;
	var sextet = 0;
	var leftovers = 0;
	var octet = 0;

	processObject++;
	for (i=0; i < str.length; i++) {
		app.setProgress (i/str.length, processFile+': encoding embedded data #'+processObject+'...');
		octet = str.charCodeAt(i);
		switch (i%3) {
			case 0:
				sextet = (octet >> 2) & 0x3F;
				leftovers = octet & 0x03 ;
				break;

			case 1:
				sextet = (leftovers << 4) | ((octet & 0xF0) >> 4);
				leftovers = octet & 0x0F ;
				break;

			case 2:
				sextet = (leftovers << 2) | ((octet & 0xC0) >> 6);
				leftovers = (octet & 0x3F);
				break;
		}
		code += b642c(sextet);
		if ((i%3) == 2)
			code += b642c(leftovers);
	}

	switch (str.length%3) {
		case 0:
			break ;

		case 1:
			leftovers =  leftovers << 4 ;
			code += b642c(leftovers)+'==';
			break ;

		case 2:
			leftovers = leftovers << 2 ;
			code += b642c(leftovers)+'=';
			break ;
	}

	for (i=0; i<code.length; i+=76)
		result += code.substr (i, 76) + '\n';

	return (result);
}

// encodes as quoted printable
function qpencode (str) {
	var output = '';
	var newline = '';
	var dec, code;
	var nl = 10, ret = 13;

	while (str.charCodeAt (str.length-1) == nl || str.charCodeAt (str.length-1) == ret)
		str = str.substr (0, str.length-1);

	for (var i=0; i<str.length; i++) {
		code = '';
		dec = str.charCodeAt(i);
		if ((dec == 32) && (str.charCodeAt(i+1) == nl || str.charCodeAt(i+1) == ret))	// convert space at eol only
			code = '=20';
		else if (dec == nl || dec == ret) {
			output += newline + '\n';
			newline = '';
		}
		else if (dec == 9)
			; // Do nothing if a tab.
		else if ((dec == 61) || (dec < 32 ) || (dec > 126))
			code = '=' + dec2hex(dec);
		else
			code = String.fromCharCode(dec);

		if ((newline.length + code.length) >= 76) {
			output += newline + '=\n';
			newline = '';
		}
		newline += code;
	}
	output += newline;
	return output;
}

// reads and b64-enocdes a file
function data2b64 (filename, baseFilename) {
	var dataFile = JSXFile (absoluteURL(filename, baseFilename));
	if (dataFile != null && dataFile.open('rb', 'BINARY')) {
		var dataData = dataFile.read();
		dataFile.close();
		return (b64encode(dataData));
	}
	else
		writeln('error reading: '+filename);
}
